]> git.ipfire.org Git - thirdparty/gcc.git/blame - maintainer-scripts/gcc_release
cl
[thirdparty/gcc.git] / maintainer-scripts / gcc_release
CommitLineData
b5842c1f 1#! /bin/sh
2
3########################################################################
4#
5# File: gcc_release
6# Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
7# Date: 2001-05-25
8#
9# Contents:
10# Script to create a GCC release.
11#
12# Copyright (c) 2001 Free Software Foundation.
13#
14# This file is part of GNU CC.
15#
16# GNU CC is free software; you can redistribute it and/or modify
17# it under the terms of the GNU General Public License as published by
18# the Free Software Foundation; either version 2, or (at your option)
19# any later version.
20#
21# GNU CC is distributed in the hope that it will be useful,
22# but WITHOUT ANY WARRANTY; without even the implied warranty of
23# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
24# GNU General Public License for more details.
25#
26# You should have received a copy of the GNU General Public License
27# along with GNU CC; see the file COPYING. If not, write to
28# the Free Software Foundation, 59 Temple Place - Suite 330,
29# Boston, MA 02111-1307, USA.
30#
31########################################################################
32
33########################################################################
34# Notes
35########################################################################
36
37# Here is an example usage of this script, to create a GCC 3.0.2
38# prerelease:
39#
40# gcc_release -r 3.0.2
41#
42# This script will automatically use the head of the release branch
43# to generate the release.
44
45########################################################################
46# Functions
47########################################################################
48
49# Issue the error message given by $1 and exit with a non-zero
50# exit code.
51
52error() {
53 echo "gcc_release: error: $1"
54 exit 1
55}
56
57# Issue the informational message given by $1.
58
59inform() {
60 echo "gcc_release: $1"
61}
62
63# Issue a usage message explaining how to use this script.
64
65usage() {
66cat <<EOF
67gcc_release [-d destination]
68 [-u username]
69 [-r release]
70 [-t tag]
71 [-p previous-tarball]
72 [-s] [-f] [-l]
73EOF
74 exit 1
75}
76
77# Change to the directory given by $1.
78
79changedir() {
80 cd $1 || \
81 error "Could not change directory to $1"
82}
83
84# Each of the arguments is a directory name, relative to the top
85# of the source tree. Return another name for that directory, relative
86# to the working directory.
87
88adjust_dirs() {
89 for x in $@; do
90 echo `basename ${SOURCE_DIRECTORY}`/$x
91 done
92}
93
94# Build the source tree that will be the basis for the release
95# in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
96
97build_sources() {
98 # If the WORKING_DIRECTORY already exists, do not risk destroying it.
99 if [ -r ${WORKING_DIRECTORY} ]; then
100 error "\`${WORKING_DIRECTORY}' already exists"
101 fi
102 # Create the WORKING_DIRECTORY.
103 mkdir "${WORKING_DIRECTORY}" \
104 || error "Could not create \`${WORKING_DIRECTORY}'"
105 changedir "${WORKING_DIRECTORY}"
106
107 # If this is a final release, make sure that the ChangeLogs
108 # and version strings are updated.
109 if [ ${FINAL} -ne 0 ]; then
110 inform "Updating ChangeLogs and version files"
111
112 ${CVS} co -d "`basename ${SOURCE_DIRECTORY}`" \
113 -r ${BRANCH} gcc || \
114 error "Could not check out release sources"
115 for x in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
116 cat - ${x} > ${x}.new <<EOF
117${LONG_DATE} Release Manager
118
119 * GCC ${RELEASE} Released.
120
121EOF
122 mv ${x}.new ${x} || \
123 error "Could not update ${x}"
124 (changedir `dirname ${x}` && \
125 ${CVS} ci -m 'Mark ChangeLog' `basename ${x}`) || \
126 error "Could not commit ${x}"
127 done
128
129 # Update `gcc/version.c'. There are other version files
130 # as well, which should have release status updated.
131 for x in gcc/version.c; do
132 y=`basename ${x}`
133 (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
134 sed -e 's|= \".*\"|= \"'${RELEASE}'\"|g' < ${y} > ${y}.new && \
135 mv ${y}.new ${y} && \
136 ${CVS} ci -m 'Update version' ${y}) || \
137 error "Could not update ${x}"
138 done
139 for x in gcc/f/version.c libf2c/libF77/Version.c \
140 libf2c/libI77/Version.c libf2c/libU77/Version.c; do
141 y=`basename ${x}`
142 (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
143 sed -e 's/experimental\|prerelease/release/g' < ${y} > ${y}.new && \
144 mv ${y}.new ${y} && \
145 ${CVS} ci -m 'Update version' ${y}) || \
146 error "Could not update ${x}"
147 done
148
149 # Make sure we tag the sources for a final release.
150 TAG="gcc_`echo ${RELEASE} | tr . _`_release"
151
152 rm -rf ${SOURCE_DIRECTORY}
153 fi
154
155 # Tag the sources.
156 if [ -n "${TAG}" ]; then
157 inform "Tagging release sources"
158 ${CVS} rtag -r ${BRANCH} -F ${TAG} gcc || \
159 error "Could not tag release sources"
160 BRANCH=$TAG
161 fi
162
163 # Export the current sources.
164 inform "Retrieving release sources"
165 ${CVS} \
166 export -d "`basename ${SOURCE_DIRECTORY}`" \
167 -r ${BRANCH} gcc || \
168 error "Could not retrieve release sources"
169
170 # Run gcc_update on them to set up the timestamps nicely.
171 changedir "gcc-${RELEASE}"
172 contrib/gcc_update --touch
173
174 # Obtain some documentation files from the wwwdocs module.
175 inform "Retrieving HTML documentation"
176 changedir "${WORKING_DIRECTORY}"
177 for x in bugs gnats faq; do
178 (${CVS} export -r HEAD wwwdocs/htdocs/${x}.html && \
179 cp ${WORKING_DIRECTORY}/wwwdocs/htdocs/${x}.html \
180 ${SOURCE_DIRECTORY}) || \
181 error "Could not retrieve ${x}.html"
182 done
183
184 inform "Generating plain-text documentation from HTML"
185 changedir "${SOURCE_DIRECTORY}"
186 for file in *.html; do
187 newfile=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
188 (${ENV} TERM=vt100 lynx -dump $file \
189 | sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
190 > $newfile) || \
191 error "Could not regenerate documentation"
192 done
193
194 # For a prerelease or real release, we need to generate additional
195 # files not present in CVS.
196 changedir "${SOURCE_DIRECTORY}"
197 if [ $SNAPSHOT -ne 1 ]; then
198 # Generate the documentation.
199 inform "Building install docs"
200 SOURCEDIR=${SOURCE_DIRECTORY}/gcc/doc
201 DESTDIR=${SOURCE_DIRECTORY}/INSTALL
202 export SOURCEDIR
203 export DESTDIR
204 ${SOURCE_DIRECTORY}/gcc/doc/install.texi2html
205
206 # Regenerate the NEWS file.
207 contrib/gennews > gcc/NEWS || \
208 error "Could not regenerate NEWS files"
209
210 # Now, we must build the compiler in order to create any generated
211 # files that are supposed to go in the source directory. This is
212 # also a good sanity check to make sure that the release builds
213 # on at least one platform.
214 inform "Building compiler"
215 OBJECT_DIRECTORY=../objdir
216 contrib/gcc_build -d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} build || \
217 error "Could not rebuild GCC"
218
219 # Regenerate the Fotran NEWS and BUGS files.
220 (cd ${OBJECT_DIRECTORY}/gcc && make f77.rebuilt) || \
221 error "Could not regenerate Fortran NEWS and BUGS files"
222 fi
223
224 # Move message catalogs to source directory.
225 mv ../objdir/gcc/po/*.gmo gcc/po/
226
227 # Create a `.brik' file to use for checking the validity of the
228 # release.
229 changedir "${SOURCE_DIRECTORY}"
230 BRIK_FILE=`mktemp /tmp/gcc_release.XXXXXXX`
231 ((find . -type f | sort > $BRIK_FILE) && \
232 brik -Gb -f ${BRIK_FILE} > .brik && \
233 rm ${BRIK_FILE}) || \
234 error "Could not compute brik checksum"
235}
236
237# Buid a single tarfile. The first argument is the name of the name
238# of the tarfile to build, without any suffixes. They will be added
239# automatically. The rest of the arguments are the files or
240# directories to include.
241
242build_tarfile() {
243 # Get the name of the destination tar file.
244 TARFILE="$1.tar.gz"
245 shift
246
247 # Build the tar file itself.
248 (${TAR} cf - "$@" | ${GZIP} > ${TARFILE}) || \
249 error "Could not build tarfile"
250 FILE_LIST="${FILE_LIST} ${TARFILE}"
251}
252
253# Build the various tar files for the release.
254
255build_tarfiles() {
256 inform "Building tarfiles"
257
258 changedir "${WORKING_DIRECTORY}"
259
260 # The GNU Coding Standards specify that all files should
261 # world readable.
262 chmod -R a+r ${SOURCE_DIRECTORY}
263 # And that all directories have mode 777.
264 find ${SOURCE_DIRECTORY} -type d -exec chmod 777 {} \;
265
266 # Build one huge tarfile for the entire distribution.
267 build_tarfile gcc-${RELEASE} `basename ${SOURCE_DIRECTORY}`
268
269 # Now, build one for each of the languages.
5e9eb877 270 build_tarfile gcc-ada-${RELEASE} ${ADA_DIRS}
271 build_tarfile gcc-chill-${RELEASE} ${CHILL_DIRS}
b5842c1f 272 build_tarfile gcc-g++-${RELEASE} ${CPLUSPLUS_DIRS}
273 build_tarfile gcc-g77-${RELEASE} ${FORTRAN_DIRS}
274 build_tarfile gcc-java-${RELEASE} ${JAVA_DIRS}
275 build_tarfile gcc-objc-${RELEASE} ${OBJECTIVEC_DIRS}
276 build_tarfile gcc-testsuite-${RELEASE} ${TESTSUITE_DIRS}
277
278 # The core is everything else.
279 EXCLUDES=""
5e9eb877 280 for x in ${ADA_DIRS} ${CHILL_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} \
281 ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
b5842c1f 282 EXCLUDES="${EXCLUDES} --exclude $x"
283 done
284 build_tarfile gcc-core-${RELEASE} ${EXCLUDES} \
285 `basename ${SOURCE_DIRECTORY}`
286
287 # Possibly build diffs.
288 if [ -n "$OLD_TARS" ]; then
289 for old_tar in $OLD_TARS; do
290 build_diffs $old_tar
291 done
292 fi
293
294 # Build .bz2 files.
295 for f in ${FILE_LIST}; do
296 bzfile=${f%.gz}.bz2
5e9eb877 297 (zcat $f | ${BZIP2} > ${bzfile}) || error "Could not create ${bzfile}"
b5842c1f 298 FILE_LIST="${FILE_LIST} ${bzfile}"
299 done
300}
301
302# Build diffs against an old release.
303build_diffs() {
304 old_dir=${1%/*}
305 old_file=${1##*/}
306 old_vers=${old_file%.tar.gz}
307 old_vers=${old_vers#gcc-}
308 inform "Building diffs against version $old_vers"
309 for f in gcc gcc-g++ gcc-g77 gcc-java gcc-objc gcc-testsuite gcc-core; do
310 old_tar=${old_dir}/${f}-${old_vers}.tar.gz
311 new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.gz
312 if [ -e $old_tar ] && [ -e $new_tar ]; then
313 build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
314 ${f}-${old_vers}-${RELEASE}.diff.gz
315 fi
316 done
317}
318
319# Build an individual diff.
320build_diff() {
321 changedir "${WORKING_DIRECTORY}"
322 tmpdir=gccdiff.$$
323 mkdir $tmpdir || error "Could not create directory $tmpdir"
324 changedir $tmpdir
325 tar xfz $1 || error "Could not unpack $1 for diffs"
326 tar xfz $3 || error "Could not unpack $3 for diffs"
5e9eb877 327 ${DIFF} $2 $4 > ../${5%.gz}
b5842c1f 328 if [ $? -eq 2 ]; then
329 error "Trouble making diffs from $1 to $3"
330 fi
5e9eb877 331 ${GZIP} ../${5%.gz} || error "Could not gzip ../${5%.gz}"
b5842c1f 332 changedir ..
333 rm -rf $tmpdir
334 FILE_LIST="${FILE_LIST} $5"
335}
336
337# Upload the files to the FTP server.
338
339upload_files() {
340 inform "Uploading files"
341
342 changedir "${WORKING_DIRECTORY}"
343
344 if [ $LOCAL -ne 0 ]; then
345 mkdir -p "${FTP_PATH}" \
346 || error "Could not create \`${FTP_PATH}'"
347 fi
348
349 # Copy the tar files to the FTP server.
350 for x in gcc*.gz gcc*.bz2; do
351 if [ -e ${x} ]; then
352 # Make sure the file will be readable on the server.
353 chmod a+r ${x}
354 # Copy it.
355 ${SCP} ${x} ${FTP_PATH} || \
356 error "Could not upload ${x}"
357 fi
358 done
359}
360
361########################################################################
362# Initialization
363########################################################################
364
365# Today's date.
366DATE=`date "+%Y%m%d"`
367LONG_DATE=`date "+%Y-%m-%d"`
368
369# The CVS server containing the GCC repository.
370CVS_SERVER="gcc.gnu.org"
371# The path to the repository on that server.
372CVS_REPOSITORY="/cvs/gcc"
373# The CVS protocol to use.
374CVS_PROTOCOL="ext"
375# The username to use when connecting to the server.
376CVS_USERNAME="${USER}"
377
378# The path to the directory where the files are uploaded for FTP.
379FTP_PATH="gccadmin@gcc.gnu.org:~ftp/pub/gcc"
380
381# The major number for the release. For release `3.0.2' this would be
382# `3'
383RELEASE_MAJOR=""
384# The minor number for the release. For release `3.0.2' this would be
385# `0'.
386RELEASE_MINOR=""
387# The revision number for the release. For release `3.0.2' this would
388# be `2'.
389RELEASE_REVISION=""
390# The complete name of the release.
391RELEASE=""
392
393# The name of the branch from which the release should be made.
394BRANCH=""
395
396# The tag to apply to the sources used for the release.
397TAG=""
398
399# The old tarballs from which to generate diffs.
400OLD_TARS=""
401
402# The directory that will be used to construct the release. The
403# release itself will be placed in a subdirectory of this diretory.
404DESTINATION=${HOME}
405# The subdirectory.
406WORKING_DIRECTORY=""
407# The directory that will contain the GCC sources.
408SOURCE_DIRECTORY=""
409
410# The directories that should be part of the various language-specific
411# tar files. These are all relative to the top of the source tree.
5e9eb877 412ADA_DIRS="gcc/ada"
413CHILL_DIRS="gcc/ch libchill"
b5842c1f 414CPLUSPLUS_DIRS="gcc/cp libstdc++-v3"
415FORTRAN_DIRS="gcc/f libf2c"
416JAVA_DIRS="gcc/java libjava libffi fastjar zlib boehm-gc"
417OBJECTIVEC_DIRS="gcc/objc libobjc"
418TESTSUITE_DIRS="gcc/testsuite"
419
420# Non-zero if this is the final release, rather than a prerelease.
421FINAL=0
422
423# Non-zero if we are building a snapshot, and don't build gcc or
424# include generated files.
425SNAPSHOT=0
426
427# Non-zero if we are running locally on gcc.gnu.org, and use local CVS
428# and copy directly to the FTP directory.
429LOCAL=0
430
431# Major operation modes.
432MODE_SOURCES=0
433MODE_TARFILES=0
434MODE_UPLOAD=0
435
436# Files generated to upload.
437FILE_LIST=""
438
439# Programs we use.
440
441BZIP2="${BZIP2:-bzip2}"
442CVS="${CVS:-cvs -f -Q -z9}"
443DIFF="${DIFF:-diff -Nrc3pad}"
444ENV="${ENV:-env}"
445GZIP="${GZIP:-gzip --best}"
446SCP="${SCP:-scp -p}"
447TAR="${TAR:-tar}"
448
449########################################################################
450# Command Line Processing
451########################################################################
452
453# Parse the options.
454while getopts "d:fr:u:t:p:sl" ARG; do
455 case $ARG in
456 d) DESTINATION="${OPTARG}";;
457 r) RELEASE="${OPTARG}";;
458 t) TAG="${OPTARG}";;
459 u) CVS_USERNAME="${OPTARG}";;
460 f) FINAL=1;;
461 s) SNAPSHOT=1;;
462 l) LOCAL=1
463 SCP=cp
464 FTP_PATH=~ftp/pub/gcc
df21ac14 465 PATH=~:/usr/local/bin:$PATH;;
b5842c1f 466 p) OLD_TARS="${OLD_TARS} ${OPTARG}";;
467 \?) usage;;
468 esac
469done
470shift `expr ${OPTIND} - 1`
471
472# Perform consistency checking.
3beae759 473if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
b5842c1f 474 error "No username specified"
475fi
476
477if [ ! -d ${DESTINATION} ]; then
478 error "\`${DESTINATION}' is not a directory"
479fi
480
481if [ $SNAPSHOT -eq 0 ]; then
482 if [ -z ${RELEASE} ]; then
483 error "No release number specified"
484 fi
485
486 # Compute the major and minor release numbers.
487 RELEASE_MAJOR=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
488 RELEASE_MINOR=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
489 RELEASE_REVISION=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
490
491 if [ -z "${RELEASE_MAJOR}" ] || [ -z "${RELEASE_MINOR}" ]; then
492 error "Release number \`${RELEASE}' is invalid"
493 fi
494
495 # Compute the full name of the release.
496 if [ -z "${RELEASE_REVISION}" ]; then
497 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}"
498 else
499 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
500 fi
501
502 # Compute the name of the branch, which is based solely on the major
503 # and minor release numbers.
504 BRANCH="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
505
506 # If this is not a final release, set various parameters acordingly.
507 if [ ${FINAL} -ne 1 ]; then
508 RELEASE="${RELEASE}-${DATE}"
509 FTP_PATH="${FTP_PATH}/snapshots"
510 else
511 FTP_PATH="${FTP_PATH}/releases/gcc-${RELEASE}"
512 fi
513else
514 RELEASE=$DATE
5e9eb877 515 # For now snapshots come from the mainline.
516 BRANCH=HEAD
b5842c1f 517 FTP_PATH="${FTP_PATH}/snapshots/${LONG_DATE}"
518 TAG=gcc_ss_${DATE}
519
520 # Building locally on gcc.gnu.org, we know what the last snapshot date
521 # was.
522 if [ $LOCAL -ne 0 ]; then
523 LAST_DATE=`cat ~/.snapshot_date`
b5842c1f 524 LAST_LONG_DATE=`date --date=$LAST_DATE +%Y-%m-%d`
525 LAST_DIR=~ftp/pub/gcc/snapshots/${LAST_LONG_DATE}
526 OLD_TARS=${LAST_DIR}/gcc-${LAST_DATE}.tar.gz
527 fi
528fi
529
530# Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
531WORKING_DIRECTORY="${DESTINATION}/gcc-${RELEASE}"
532SOURCE_DIRECTORY="${WORKING_DIRECTORY}/gcc-${RELEASE}"
533
534# Recompute the names of all the language-specific directories,
535# relative to the WORKING_DIRECTORY.
5e9eb877 536ADA_DIRS=`adjust_dirs ${ADA_DIRS}`
537CHILL_DIRS=`adjust_dirs ${CHILL_DIRS}`
b5842c1f 538CPLUSPLUS_DIRS=`adjust_dirs ${CPLUSPLUS_DIRS}`
539FORTRAN_DIRS=`adjust_dirs ${FORTRAN_DIRS}`
540JAVA_DIRS=`adjust_dirs ${JAVA_DIRS}`
541OBJECTIVEC_DIRS=`adjust_dirs ${OBJECTIVEC_DIRS}`
542TESTSUITE_DIRS=`adjust_dirs ${TESTSUITE_DIRS}`
543
544# Set up CVSROOT.
545if [ $LOCAL -eq 0 ]; then
546 CVSROOT=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
547 CVSROOT="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
548else
549 CVSROOT="${CVS_REPOSITORY}"
550fi
551export CVSROOT
552
553########################################################################
554# Main Program
555########################################################################
556
557# Handle the major modes.
558while [ $# -ne 0 ]; do
559 case $1 in
560 sources) MODE_SOURCES=1;;
561 tarfiles) MODE_TARFILES=1;;
562 upload) MODE_UPLOAD=1;;
563 all) MODE_SOURCES=1; MODE_TARFILES=1; MODE_UPLOAD=1;;
564 *) error "Unknown mode $1";;
565 esac
566 shift
567done
568
569# Build the source directory.
570
571if [ $MODE_SOURCES -ne 0 ]; then
572 build_sources
573fi
574
575# Build the tar files.
576
577if [ $MODE_TARFILES -ne 0 ]; then
578 build_tarfiles
579fi
580
581# Upload them to the FTP server.
582
583if [ $MODE_UPLOAD -ne 0 ]; then
584 upload_files
585
586 # For snapshots, make some further updates.
587 if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
588 # Update links on the FTP server.
589 TEXT_DATE=`date --date=$DATE +%B\ %d,\ %Y`
b5842c1f 590 cd ~ftp/pub/gcc/snapshots
18619e05 591 sed -e "s%@DATE@%$DATE%g" -e "s%@LAST_DATE@%$LAST_DATE%g" \
592 -e "s%@LONG_DATE@%$LONG_DATE%g" \
593 -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-README > $$
b5842c1f 594 mv $$ README
18619e05 595 sed -e "s%@DATE@%$DATE%g" -e "s%@LAST_DATE@%$LAST_DATE%g" \
596 -e "s%@LONG_DATE@%$LONG_DATE%g" \
597 -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-index.html > $$
b5842c1f 598 mv $$ index.html
599
600 touch LATEST-IS-$LONG_DATE
601 rm -f LATEST-IS-$LAST_LONG_DATE
602
603 # Update snapshot date file.
604 changedir ~
b5842c1f 605 echo $DATE >.snapshot_date
606
607 # Update gcc_latest_snapshot tag.
608 ${CVS} rtag -d gcc_latest_snapshot gcc
609 ${CVS} rtag -rgcc_ss_${DATE} gcc_latest_snapshot gcc
610
611 # Announce the snapshot.
18619e05 612 export QMAILHOST=gcc.gnu.org
b5842c1f 613 mail -s "gcc-ss-$DATE is now available" gcc@gcc.gnu.org < ~ftp/pub/gcc/snapshots/README
614
615 # Remove working directory
616 rm -rf ${WORKING_DIRECTORY}
617 fi
618fi